## TypeScript FP Compose

![Typescript FP](https://avatars1.githubusercontent.com/u/52818784?s=100)

Curried compose functions with generic types.

#### Requirements
- Node.js
- Typescript 3+

#### Dependencies
- none

#### Install
```
npm install @typescript-fp/compose
```

#### Compile
- Transpile Typescript to ES6 in the `lib` directory
```
npm run build
```

#### Tests
- Run unit tests
- Generate code coverage report in the `coverage` directory
```
npm run test
```

#### Docs
- Generate documentation in the `docs` directory
```
npm run docs
```

#### Usage
```
import {composeFgGab as compose} from "@typescript-fp/compose"

const add = (a: number) => (b: number) => a + b;
const increment = add(1);
const composedFn = compose(increment)(add);

composedFn(5)(5)
```
