"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFab_1 = require("../composeFab");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFab_1.composeFab.length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([utilities_1.a, utilities_1.b]);
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([utilities_1.b, utilities_1.a]);
    });
});
//# sourceMappingURL=composeFab.spec.js.map