"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFba_1 = require("../composeFba");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFba_1.composeFba.length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([utilities_1.b, utilities_1.a]);
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([utilities_1.a, utilities_1.b]);
    });
});
//# sourceMappingURL=composeFba.spec.js.map