"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFcab_1 = require("../composeFcab");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFcab_1.composeFcab.length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([utilities_1.c, utilities_1.a, utilities_1.b]);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([utilities_1.b, utilities_1.a, utilities_1.c]);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([utilities_1.c, utilities_1.b, utilities_1.a]);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([utilities_1.a, utilities_1.b, utilities_1.c]);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.c)(utilities_1.a)(utilities_1.b)).toStrictEqual([utilities_1.b, utilities_1.c, utilities_1.a]);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a)).toStrictEqual([utilities_1.a, utilities_1.c, utilities_1.b]);
    });
});
//# sourceMappingURL=composeFcab.spec.js.map