"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgGa_1 = require("../composeFgGa");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgGa_1.composeFgGa.length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1)(utilities_1.a)).toStrictEqual([[utilities_1.a]]);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1)(utilities_1.b)).toStrictEqual([[utilities_1.b]]);
    });
});
//# sourceMappingURL=composeFgGa.spec.js.map