"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgGab_1 = require("../composeFgGab");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgGab_1.composeFgGab.length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.b]]);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.a]]);
    });
});
//# sourceMappingURL=composeFgGab.spec.js.map