"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgGabc_1 = require("../composeFgGabc");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgGabc_1.composeFgGabc.length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([[utilities_1.a, utilities_1.b, utilities_1.c]]);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.c, utilities_1.b]]);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([[utilities_1.b, utilities_1.a, utilities_1.c]]);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.c, utilities_1.a]]);
    });
});
//# sourceMappingURL=composeFgGabc.spec.js.map