"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgaGa_1 = require("../composeFgaGa");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgaGa_1.composeFgaGa.length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)).toStrictEqual([[utilities_1.a], utilities_1.a]);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b)).toStrictEqual([[utilities_1.b], utilities_1.b]);
    });
});
//# sourceMappingURL=composeFgaGa.spec.js.map