"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgaGab_1 = require("../composeFgaGab");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgaGab_1.composeFgaGab.length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.b], utilities_1.a]);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.a], utilities_1.b]);
    });
});
//# sourceMappingURL=composeFgaGab.spec.js.map