"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgaGabc_1 = require("../composeFgaGabc");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgaGabc_1.composeFgaGabc.length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([[utilities_1.a, utilities_1.b, utilities_1.c], utilities_1.a]);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.c, utilities_1.b], utilities_1.a]);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([[utilities_1.b, utilities_1.a, utilities_1.c], utilities_1.b]);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.c, utilities_1.a], utilities_1.b]);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.c)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.c, utilities_1.a, utilities_1.b], utilities_1.c]);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.c, utilities_1.b, utilities_1.a], utilities_1.c]);
    });
});
//# sourceMappingURL=composeFgaGabc.spec.js.map