"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgaGb_1 = require("../composeFgaGb");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgaGb_1.composeFgaGb.length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.b], utilities_1.a]);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.a], utilities_1.b]);
    });
});
//# sourceMappingURL=composeFgaGb.spec.js.map