"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgabGa_1 = require("../composeFgabGa");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgabGa_1.composeFgabGa.length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.a], utilities_1.a, utilities_1.b]);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.b], utilities_1.b, utilities_1.a]);
    });
});
//# sourceMappingURL=composeFgabGa.spec.js.map