"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgabGab_1 = require("../composeFgabGab");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgabGab_1.composeFgabGab.length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.b], utilities_1.a, utilities_1.b]);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.a], utilities_1.b, utilities_1.a]);
    });
});
//# sourceMappingURL=composeFgabGab.spec.js.map