"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgabGabc_1 = require("../composeFgabGabc");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgabGabc_1.composeFgabGabc.length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([[utilities_1.a, utilities_1.b, utilities_1.c], utilities_1.a, utilities_1.b]);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.c, utilities_1.b], utilities_1.a, utilities_1.c]);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([[utilities_1.b, utilities_1.a, utilities_1.c], utilities_1.b, utilities_1.a]);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.c, utilities_1.a], utilities_1.b, utilities_1.c]);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.c)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.c, utilities_1.a, utilities_1.b], utilities_1.c, utilities_1.a]);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.c, utilities_1.b, utilities_1.a], utilities_1.c, utilities_1.b]);
    });
});
//# sourceMappingURL=composeFgabGabc.spec.js.map