"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgabcGa_1 = require("../composeFgabcGa");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgabcGa_1.composeFgabcGa.length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([[utilities_1.a], utilities_1.a, utilities_1.b, utilities_1.c]);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([[utilities_1.a], utilities_1.a, utilities_1.c, utilities_1.b]);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([[utilities_1.b], utilities_1.b, utilities_1.a, utilities_1.c]);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([[utilities_1.b], utilities_1.b, utilities_1.c, utilities_1.a]);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.c)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.c], utilities_1.c, utilities_1.a, utilities_1.b]);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.c)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.c], utilities_1.c, utilities_1.b, utilities_1.a]);
    });
});
//# sourceMappingURL=composeFgabcGa.spec.js.map