"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgbGa_1 = require("../composeFgbGa");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgbGa_1.composeFgbGa.length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.a], utilities_1.b]);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.b], utilities_1.a]);
    });
});
//# sourceMappingURL=composeFgbGa.spec.js.map