export interface ComposeFab {
    <F, A, B>(f: (a: A) => (b: B) => F): (a: A) => (b: B) => F;
}

/**
 * @name composeFab
 * @summary
 * - `Signature :: (f: (a: A) => (b: B) => F) => (a: A) => (b: B) => F`
 * - `Composition :: f(a)(b)`
 */
export const composeFab: ComposeFab = f => a => b => f(a)(b);
