export interface ComposeFabc {
    <F, A, B, C>(f: (a: A) => (b: B) => (c: C) => F): (a: A) => (b: B) => (c: C) => F;
}

/**
 * @name composeFabc
 * @summary
 * - `Signature :: (f: (a: A) => (b: B) => (c: C) => F) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(a)(b)(c)`
 */
export const composeFabc: ComposeFabc = f => a => b => c => f(a)(b)(c);
