export interface ComposeFba {
    <F, A, B>(f: (b: B) => (a: A) => F): (a: A) => (b: B) => F;
}

/**
 * @name composeFba
 * @summary
 * - `Signature :: (f: (b: B) => (a: A) => F) => (a: A) => (b: B) => F`
 * - `Composition :: f(b)(a)`
 */
export const composeFba: ComposeFba = f => a => b => f(b)(a);
