export interface ComposeFbac {
    <F, A, B, C>(f: (b: B) => (a: A) => (c: C) => F): (a: A) => (b: B) => (c: C) => F;
}

/**
 * @name composeFbac
 * @summary
 * - `Signature :: (f: (b: B) => (a: A) => (c: C) => F) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(b)(a)(c)`
 */
export const composeFbac: ComposeFbac = f => a => b => c => f(b)(a)(c);
