export interface ComposeFbca {
    <F, A, B, C>(f: (b: B) => (c: C) => (a: A) => F): (a: A) => (b: B) => (c: C) => F;
}

/**
 * @name composeFbca
 * @summary
 * - `Signature :: (f: (b: B) => (c: C) => (a: A) => F) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(b)(c)(a)`
 */
export const composeFbca: ComposeFbca = f => a => b => c => f(b)(c)(a);
