export interface ComposeFcba {
    <F, A, B, C>(f: (c: C) => (b: B) => (a: A) => F): (a: A) => (b: B) => (c: C) => F;
}

/**
 * @name composeFcba
 * @summary
 * - `Signature :: (f: (c: C) => (b: B) => (a: A) => F) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(c)(b)(a)`
 */
export const composeFcba: ComposeFcba = f => a => b => c => f(c)(b)(a);
