export interface ComposeFgGab {
    <F, G, A, B>(f: (g: G) => F): (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgGab
 * @summary
 * - `Signature :: (f: (g: G) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(a)(b))`
 */
export const composeFgGab: ComposeFgGab = f => g => a => b => f(g(a)(b));
