export interface ComposeFgGabc {
    <F, G, A, B, C>(f: (g: G) => F): (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgGabc
 * @summary
 * - `Signature :: (f: (g: G) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(a)(b)(c))`
 */
export const composeFgGabc: ComposeFgGabc = f => g => a => b => c => f(g(a)(b)(c));
