export interface ComposeFgaGa {
    <F, G, A>(f: (g: G) => (a: A) => F): (g: (a: A) => G) => (a: A) => F
}

/**
 * @name composeFgaGa
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => G) => (a: A) => F`
 * - `Composition :: f(g(a))(a)`
 */
export const composeFgaGa: ComposeFgaGa = f => g => a => f(g(a))(a);
