export interface ComposeFgaGab {
    <F, G, A>(f: (g: G) => (a: A) => F): <B>(g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgaGab
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(a)(b))(a)`
 */
export const composeFgaGab: ComposeFgaGab = f => g => a => b => f(g(a)(b))(a);
