export interface ComposeFgaGabc {
    <F, G, A, B, C>(f: (g: G) => (a: A) => F): (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgaGabc
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(a)(b)(c))(a)`
 */
export const composeFgaGabc: ComposeFgaGabc = f => g => a => b => c => f(g(a)(b)(c))(a);
