export interface ComposeFgaGb {
    <F, G, A, B>(f: (g: G) => (a: A) => F): (g: (b: B) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgaGb
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => F) => (g: (b: B) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(b))(a)`
 */
export const composeFgaGb: ComposeFgaGb = f => g => a => b => f(g(b))(a);
