export interface ComposeFgabGa {
    <F, G, A, B>(f: (g: G) => (a: A) => (b: B) => F): (g: (a: A) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgabGa
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(a))(a)(b)`
 */
export const composeFgabGa: ComposeFgabGa = f => g => a => b => f(g(a))(a)(b);
