export interface ComposeFgabGab {
    <F, G, A, B>(f: (g: G) => (a: A) => (b: B) => F): (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgabGab
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => (b: B) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(a)(b))(a)(b)`
 */
export const composeFgabGab: ComposeFgabGab = f => g => a => b => f(g(a)(b))(a)(b);
