export interface ComposeFgabGabc {
    <F, G, A, B>(f: (g: G) => (a: A) => (b: B) => F): <C>(g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgabGabc
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(a)(b)(c))(a)(b)`
 */
export const composeFgabGabc: ComposeFgabGabc = f => g => a => b => c => f(g(a)(b)(c))(a)(b);
