export interface ComposeFgabcGa {
    <F, G, A, B, C>(f: (g: G) => (a: A) => (b: B) => (c: C) => F): (g: (a: A) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgabcGa
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (a: A) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(a))(a)(b)(c)`
 */
export const composeFgabcGa: ComposeFgabcGa = f => g => a => b => c => f(g(a))(a)(b)(c);
