export interface ComposeFgabcGabc {
    <F, G, A, B, C>(f: (g: G) => (a: A) => (b: B) => (c: C) => F): (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgabcGabc
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (a: A) => (b: B) => (c: C) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(a)(b)(c))(a)(b)(c)`
 */
export const composeFgabcGabc: ComposeFgabcGabc = f => g => a => b => c => f(g(a)(b)(c))(a)(b)(c);
