export interface ComposeFgabcGb {
    <F, G, A, B, C>(f: (g: G) => (a: A) => (b: B) => (c: C) => F): (g: (b: B) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgabcGb
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (b: B) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(b))(a)(b)(c)`
 */
export const composeFgabcGb: ComposeFgabcGb = f => g => a => b => c => f(g(b))(a)(b)(c);
