export interface ComposeFgabcGc {
    <F, G, A, B, C>(f: (g: G) => (a: A) => (b: B) => (c: C) => F): (g: (c: C) => G) => (a: A) => (b: B) => (c: C) => F
}

/**
 * @name composeFgabcGc
 * @summary
 * - `Signature :: (f: (g: G) => (a: A) => (b: B) => (c: C) => F) => (g: (c: C) => G) => (a: A) => (b: B) => (c: C) => F`
 * - `Composition :: f(g(c))(a)(b)(c)`
 */
export const composeFgabcGc: ComposeFgabcGc = f => g => a => b => c => f(g(c))(a)(b)(c);
