export interface ComposeFgbGa {
    <F, G, A, B>(f: (g: G) => (b: B) => F): (g: (a: A) => G) => (a: A) => (b: B) => F
}

/**
 * @name composeFgbGa
 * @summary
 * - `Signature :: (f: (g: G) => (b: B) => F) => (g: (a: A) => G) => (a: A) => (b: B) => F`
 * - `Composition :: f(g(a))(b)`
 */
export const composeFgbGa: ComposeFgbGa = f => g => a => b => f(g(a))(b);
