import {composeFa as compose} from "../composeFa";
import {a, b, fn1 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(a)).toStrictEqual([a]);
        expect(compose(F)(b)).toStrictEqual([b]);
    });

});
