import {composeFab as compose} from "../composeFab";
import {a, b, fn2 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
        expect(compose(F)(a)(b).length).toStrictEqual(2);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(a)(b)).toStrictEqual([a, b]);
        expect(compose(F)(b)(a)).toStrictEqual([b, a]);
    });

});
