import {composeFbca as compose} from "../composeFbca";
import {a, b, c, fn3 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
        expect(compose(F)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(a)(b)(c).length).toStrictEqual(3);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(a)(b)(c)).toStrictEqual([b, c, a]);
        expect(compose(F)(a)(c)(b)).toStrictEqual([c, b, a]);
        expect(compose(F)(b)(a)(c)).toStrictEqual([a, c, b]);
        expect(compose(F)(b)(c)(a)).toStrictEqual([c, a, b]);
        expect(compose(F)(c)(a)(b)).toStrictEqual([a, b, c]);
        expect(compose(F)(c)(b)(a)).toStrictEqual([b, a, c]);
    });

});
