import {composeFgGa as compose} from "../composeFgGa";
import {a, b, fn1 as F, fn1 as G} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)).toStrictEqual([[a]]);
        expect(compose(F)(G)(b)).toStrictEqual([[b]]);
    });

});
