import {composeFgaGa as compose} from "../composeFgaGa";
import {a, b, fn1 as G, fn2 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(2);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)).toStrictEqual([[a], a]);
        expect(compose(F)(G)(b)).toStrictEqual([[b], b]);
    });

});
