import {composeFgabGa as compose} from "../composeFgabGa";
import {a, b, fn1 as G, fn3 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(3);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)(b)).toStrictEqual([[a], a, b]);
        expect(compose(F)(G)(b)(a)).toStrictEqual([[b], b, a]);
    });

});
