import {composeFgabGabc as compose} from "../composeFgabGabc";
import {a, b, c, fn3 as G, fn3 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b)(c).length).toStrictEqual(3);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)(b)(c)).toStrictEqual([[a, b, c], a, b]);
        expect(compose(F)(G)(a)(c)(b)).toStrictEqual([[a, c, b], a, c]);
        expect(compose(F)(G)(b)(a)(c)).toStrictEqual([[b, a, c], b, a]);
        expect(compose(F)(G)(b)(c)(a)).toStrictEqual([[b, c, a], b, c]);
        expect(compose(F)(G)(c)(a)(b)).toStrictEqual([[c, a, b], c, a]);
        expect(compose(F)(G)(c)(b)(a)).toStrictEqual([[c, b, a], c, b]);
    });

});
