import {composeFgabcGb as compose} from "../composeFgabcGb";
import {a, b, c, fn1 as G, fn4 as F} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b)(c).length).toStrictEqual(4);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)(b)(c)).toStrictEqual([[b], a, b, c]);
        expect(compose(F)(G)(a)(c)(b)).toStrictEqual([[c], a, c, b]);
        expect(compose(F)(G)(b)(a)(c)).toStrictEqual([[a], b, a, c]);
        expect(compose(F)(G)(b)(c)(a)).toStrictEqual([[c], b, c, a]);
        expect(compose(F)(G)(c)(a)(b)).toStrictEqual([[a], c, a, b]);
        expect(compose(F)(G)(c)(b)(a)).toStrictEqual([[b], c, b, a]);
    });

});
